#!/usr/bin/env python2
#
#  Valosoitin - Audio player for EFL
#
#  Copyright 2012-2013 Kai Huuhko <kai.huuhko@gmail.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#

import evas
import elementary as elm
import ecore

from searchresults import Results

class AudioInfo(elm.Box):
    def __init__(self, parent):
        window = parent.window
        elm.Box.__init__(self, window)

        self.vs = parent
        self.t = None

        title = self.title = elm.Label(window)
        title.size_hint_align_set(-1.0, 0.0)
        title.line_wrap = elm.ELM_WRAP_CHAR
        title.ellipsis = True
        title.scale_set(2.0)
        title.text_set("")
        title.show()

        artist = self.artist = elm.Label(window)
        artist.size_hint_align_set(-1.0, 0.0)
        artist.line_wrap = elm.ELM_WRAP_CHAR
        artist.ellipsis = True
        artist.text_set("")
        artist.show()

        album = self.album = elm.Label(window)
        album.size_hint_align_set(-1.0, 0.0)
        album.line_wrap = elm.ELM_WRAP_CHAR
        album.ellipsis = True
        album.text_set("")
        album.show()

        search = self.search = elm.Entry(window)
        search.elm_event_callback_add(self.search_event_cb, parent)
        search.single_line = True
        search.focus = True
        search.show()
        f = elm.Frame(window)
        f.text = _("Search")
        f.size_hint_align_set(-1.0, 0.0)
        f.show()
        f.content = search

        audiotags = elm.Box(window)
        audiotags.size_hint_align_set(-1.0, 0.0)
        audiotags.size_hint_weight_set(1.0, 1.0)
        audiotags.pack_end(title)
        audiotags.pack_end(artist)
        audiotags.pack_end(album)
        audiotags.pack_end(f)
        audiotags.show()

        #coverimg = elm.Image(window)
        #coverimg.size_set(100, 100)
        #coverimg.show()

        self.horizontal_set(True)
        self.size_hint_weight_set(1.0, 1.0)
        self.size_hint_align_set(-1.0, 0.0)
        self.pack_end(audiotags)
        #self.pack_end(coverimg)
        self.show()

    def search_event_cb(self, obj, entry, event_type, event, parent, *args):
        if event_type == evas.EVAS_CALLBACK_KEY_UP:
            if event.keyname == "Return":
                if entry.entry:
                    s = entry.entry
                    if self.t:
                        self.t.cancel()
                    if len(s) > 2:
                        parent.search(s, self.search_cb)
            #elif event.keyname == "Escape":
                #self.close()
            else:
                if self.t:
                    self.t.delete()
                self.t = ecore.Timer(2.0, self.search_items, entry, parent)
                #self.t.start()

        return True

    def search_items(self, *args):
        entry, parent = args
        if entry.entry:
            s = entry.entry
            if len(s) > 2:
                parent.search(s, self.search_cb)

        return False

    def search_cb(self, string, result):
        reswidget = Results(self.vs, string, result)
